/********************************************************/
/*  ntapi: Native API core library                      */
/*  Copyright (C) 2013--2017  Z. Gilboa                 */
/*  Released under GPLv2 and GPLv3; see COPYING.NTAPI.  */
/********************************************************/

#include <psxtypes/psxtypes.h>
#include <ntapi/nt_tty.h>
#include <ntapi/nt_guid.h>
#include <ntapi/ntapi.h>
#include "ntapi_impl.h"

int32_t	__stdcall __ntapi_tty_query_information_service(
	__in	void *			hport,
	__out	nt_io_status_block *	iosb,
	__out	nt_tty_service_info *	svcinfo,
	__in	const nt_guid *		guid,
	__in	uint32_t		key,
	__in	uint32_t		id)
{
	int32_t			status;
	nt_tty_service_msg	msg;

	__ntapi->tt_aligned_block_memset(
		&msg,0,sizeof(msg));

	msg.header.msg_type		= NT_LPC_NEW_MESSAGE;
	msg.header.data_size		= sizeof(msg.data);
	msg.header.msg_size		= sizeof(msg);
	msg.data.ttyinfo.opcode		= NT_TTY_QUERY_INFORMATION_SERVICE;
	msg.data.svcinfo.key		= key;
	msg.data.svcinfo.id		= id;

	__ntapi->tt_guid_copy(
		&msg.data.svcinfo.attr.guid,
		guid);

	if (!hport)
		hport = __ntapi_internals()->hport_tty_session;

	if ((status = __ntapi->zw_request_wait_reply_port(hport,&msg,&msg)))
		return status;
	else if (msg.data.ttyinfo.status)
		return msg.data.ttyinfo.status;

	__ntapi->tt_generic_memcpy(
		svcinfo,
		&msg.data.svcinfo,
		sizeof(*svcinfo));

	iosb->status = NT_STATUS_SUCCESS;
	iosb->info   = sizeof(*svcinfo);

	return NT_STATUS_SUCCESS;
}
